﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media.Imaging;
using System.Windows.Media;
using System.Xml;
using System.Data;
using System.Data.Common;
using System.Configuration;
using System.IO;
using System.Globalization;
using System.Diagnostics.CodeAnalysis;
using System.ComponentModel;
using System.Reflection;
using System.Windows.Forms;

    static class Helper
    {
        #region "Variables"

        public static String _SelectedConKey = "";

        //SODSUI-239 --> Commented bcoz of msg "AvoidUnusedPrivateFields"
        //public static Boolean _IsPassWordChanged;
        public static string _ConnectionString;
        public static Boolean _IsPendingChanges;
        public static Boolean _IsSaveUser;

        // Pranav 
        public static DbConnection con;
        public static DbTransaction transac;

        private static bool _isOSRVersion38AndHigher = false;

        #endregion

        #region "Constructor"

        static Helper()
        {           
            _SelectedConKey = "";
        }

        #endregion

        #region "Properties"

        public static bool IsOSRVersion38AndHigher
        {
            get
            {
                return _isOSRVersion38AndHigher;
            }
            set
            {
                _isOSRVersion38AndHigher = value;
            }
        }

        #endregion

        #region "Methods"

       
        public static string FormatDecimalNumber(double number)
        {
            System.Globalization.CultureInfo infoNumber = new System.Globalization.CultureInfo("en-US");

            string formattedString = number.ToString(infoNumber.NumberFormat);

            return formattedString;

        }

        //SODSUI-239 --> Changed png top graphics bcoz of msg "IdentifiersShouldBeSpelledCorrectly"
        public static ImageSource GetEmbeddedResourceImage(string ImageNameIn, ImageType TypeIn)
        {
            System.IO.Stream MyStream = null;
            BitmapDecoder MyDecoder = null;
            ImageSource MyImage = null;
            System.Reflection.Assembly MyAssembly = null;
            try
            {
                // get a reference to the containing assembly
                MyAssembly = System.Reflection.Assembly.GetExecutingAssembly();
                // get a memory stream of the embedded image
                MyStream = MyAssembly.GetManifestResourceStream(ImageNameIn);

                // make sure we have a valid stream instance
                if (MyStream != null)
                {
                    // get the appropriate decoder
                    switch (TypeIn)
                    {
                        case ImageType.Bmp:
                            MyDecoder = new BmpBitmapDecoder(MyStream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
                            break;
                        case ImageType.Gif:
                            MyDecoder = new GifBitmapDecoder(MyStream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
                            break;
                        case ImageType.Icon:
                            MyDecoder = new IconBitmapDecoder(MyStream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
                            break;
                        case ImageType.Jpg:
                            MyDecoder = new JpegBitmapDecoder(MyStream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
                            break;
                        case ImageType.Graphics:
                            MyDecoder = new PngBitmapDecoder(MyStream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
                            break;
                        case ImageType.Tiff:
                            MyDecoder = new TiffBitmapDecoder(MyStream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
                            break;
                        case ImageType.Wmf:
                            MyDecoder = new WmpBitmapDecoder(MyStream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default);
                            break;
                    }
                    MyImage = MyDecoder.Frames[0];
                }
            }
            catch (Exception)
            {
                throw; //SODSUI-239 "RethrowToPreserveStackDetails"
            }
            finally
            {
                if (MyStream != null)
                {
                    MyStream.Close();
                }
            }
            return MyImage;
        }

        public static String GetConfigKeyValue(String strKey)
        {
            try
            {
                String strValue = String.Empty;
                if (System.Configuration.ConfigurationSettings.AppSettings[strKey] != null)
                {
                    strValue = System.Configuration.ConfigurationSettings.AppSettings[strKey].ToString();
                }
                return strValue;
            }
            catch (Exception)
            {
                throw; //SODSUI-239 "RethrowToPreserveStackDetails"
            }
        }

        public static void SetConfigKeyValue(String strKey, String strValue)
        {
            try
            {
                XmlDocument xmlDoc = new XmlDocument();
                xmlDoc.Load(AppDomain.CurrentDomain.BaseDirectory + "..\\..\\App.config");
                XmlNode appSettingsNode = xmlDoc.SelectSingleNode("configuration/appSettings");

                foreach (XmlNode childNode in appSettingsNode)
                {
                    if (childNode.Attributes["key"].Value == strKey)
                        childNode.Attributes["value"].Value = strValue;
                }
                xmlDoc.Save(AppDomain.CurrentDomain.BaseDirectory + "..\\..\\App.config");
                xmlDoc.Save(AppDomain.CurrentDomain.SetupInformation.ConfigurationFile);
            }
            catch (Exception)
            {
                throw; //SODSUI-239 "RethrowToPreserveStackDetails"
            }
        }

        public static Boolean IsValidDataSet(DataSet ds)
        {
            if (ds != null)
            {
                if (ds.Tables.Count != 0)
                { return true; }
                else
                { return false; }
            }
            else
            { return false; }
        }

        public static Boolean IsValidDataTable(DataTable dt)
        {
            if (dt != null)
            {
                if (dt.Rows.Count != 0)
                { return true; }
                else
                { return false; }
            }
            else
            { return false; }
        }

   
        #region Commented On 15-11-2011
        ////This method is used to store the current connection details in a clsConnection object for future reference
        //public static void SaveConnectionDetails()
        //{
        //    System.Xml.XmlNodeList appSettings = (clsConfigSettings.GetAppSettingValues() as System.Xml.XmlNodeList);
        //    //To retrieve Default connection key from DefaultConfig file(i.e. SODSDefaultconnection.config) 
        //    //set the _configType flag to DefaultConnectionFile. 
        //    clsConfigSettings._configType = clsConfigSettings.Config.DefaultConnectionFile;
        //    String strDefault = clsConfigSettings.GetAppSettingValue("DWMLastSelectedConn");
        //    for (int i = 0; i < appSettings.Count; i++)
        //    {
        //        String strKey = appSettings.Item(i).Attributes[0].Value;

        //        if (strDefault == strKey)
        //        {
        //            //To retrieve connection key from shared Config file(i.e. Dwm.exe.config) 
        //            //set the _configType flag to SharedFile. 
        //            clsConfigSettings._configType = clsConfigSettings.Config.SharedFile;
        //            String strValue = clsConfigSettings.GetAppSettingValue(strKey);
        //            String[] strData = strValue.Split('|');

        //            _CurrentConnection.ConnectionKey = strKey;
        //            _CurrentConnection.Name = strData[0];
        //            _CurrentConnection.Description = strData[1];
        //            _CurrentConnection.Server = strData[2];
        //            _CurrentConnection.DataBase = strData[3];
        //        }
        //    }
        //} 
        #endregion


        //This method is used to check whether a String object is null and return Null value accordingly
        public static Object StringToDBnull(String strCheck)
        {
            if (strCheck == null)
                return System.DBNull.Value;
            else
                return strCheck.Trim();
        }

        //This method is used to convert and return a String object into an Byte[] object or null value
        public static Object StringToBytes(String strCheck)
        {
            if (StringToDBnull(strCheck) == System.DBNull.Value)
                return System.DBNull.Value;
            else
                return Encoding.ASCII.GetBytes(strCheck);
        }

     
        /// <summary>
        /// Finds a parent of a given item on the visual tree.
        /// </summary>
        /// <typeparam name="T">The type of the queried item.</typeparam>
        /// <param name="child">A direct or indirect child of the queried item.</param>
        /// <returns>The first parent item that matches the submitted type parameter. 
        /// If not matching item can be found, a null reference is being returned.</returns>
        public static T FindVisualParent<T>(System.Windows.DependencyObject child)
          where T : System.Windows.DependencyObject
        {
            // get parent item
            System.Windows.DependencyObject parentObject = VisualTreeHelper.GetParent(child);

            // we’ve reached the end of the tree
            if (parentObject == null) return null;

            // check if the parent matches the type we’re looking for
            T parent = parentObject as T;
            if (parent != null)
            {
                return parent;
            }
            else
            {
                // use recursion to proceed with next level
                return FindVisualParent<T>(parentObject);
            }
        }

        public static string GetParsedDate(string dateValue, DateFormat formatString)
        {
            DateTime dtParsedDate;
            if (DateTime.TryParse(dateValue, out dtParsedDate))
            {
                return dtParsedDate.ToString(GetEnumDescription(formatString), CultureInfo.CurrentCulture);
            }
            else
            {
                MessageBox.Show("The string was not recognized as a valid DateTime.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, 0);
                return dateValue;
            }
        }

        public static string GetParsedTime(string timeValue)
        {
            DateTime dtParsedTime;
            if (DateTime.TryParse(timeValue, out dtParsedTime))
            {
                return dtParsedTime.ToLongTimeString();
            }
            else
            {
                MessageBox.Show("The string was not recognized as a valid DateTime.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, 0);
                return timeValue;
            }
        }

        public static string GetEnumDescription(Enum en)
        {
            Type type = en.GetType();

            MemberInfo[] memInfo = type.GetMember(en.ToString());

            if (memInfo != null && memInfo.Length > 0)
            {
                object[] attrs = memInfo[0].GetCustomAttributes(typeof(DescriptionAttribute), false);

                if (attrs != null && attrs.Length > 0)
                {
                    return ((DescriptionAttribute)attrs[0]).Description;
                }
            }

            return en.ToString();
        }

        #endregion
    }

    //SODSUI-239 --> Changed png top graphics bcoz of msg "IdentifiersShouldBeSpelledCorrectly"
    public enum ImageType
    {
        Bmp,
        Gif,
        Icon,
        Jpg,
        Graphics,
        Tiff,
        Wmf,
    }

    public enum StatusBarLocationName
    {
        Connection
    }

    public enum DateFormat
    {
        [Description("dd/MM/yyyy")]
        DateMonthYear,
        [Description("MM/dd/yyyy")]
        MonthDateYear,
    }